#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/wait.h>

int main(int argc,  char *argv[ ]) {
   pid_t pidhijo;             /* indica si el proceso deberia crear otro     */
   int error;                 /* valor devuelto por dup2                     */
   int fd[2];                 /* descriptores de la tuberia                  */
   int i;                     /* numero de este proceso (empieza en 1)       */
   int nprocs;                /* numero total de procesos en en anillo       */ 
   /* buscar en la linea de comandos un numero valido de procesos para crear */
   if ( (argc != 2) || ((nprocs = atoi (argv[1])) <= 0) ) {
       fprintf (stderr, "Uso: %s nprocs\n", argv[0]);
       return 1; 
   }  
   if (pipe (fd) == -1) {  /* conectar entrada std a salida std via la tuberia */
      perror("Fallo al crear la tuberia");
      return 1;
   }
   if ((dup2(fd[0], STDIN_FILENO) == -1) ||
       (dup2(fd[1], STDOUT_FILENO) == -1)) {
      perror("Fallo al conectar la tuberia");
      return 1;
   }
   if ((close(fd[0]) == -1) || (close(fd[1]) == -1)) {
      perror("Fallo al cerrar los descriptores adicionales");
      return 1; 
   }        
   for (i = 1; i < nprocs;  i++) {         /* crear los restantes procesos */
      if (pipe (fd) == -1) {
         fprintf(stderr, "[%ld]:fallo al crear la tuberia %d: %s\n",
                (long)getpid(), i, strerror(errno));
         return 1; 
      } 
      if ((pidhijo = fork()) == -1) {
         fprintf(stderr, "[%ld]:fallo al crear el hijo %d: %s\n",
                 (long)getpid(), i, strerror(errno));
         return 1; 
      } 
      if (pidhijo > 0)               /* proceso padre reasigna stdout */
          error = dup2(fd[1], STDOUT_FILENO);
      else                              /* proceso hijo reasigna stdin */
          error = dup2(fd[0], STDIN_FILENO);
      if (error == -1) {
         fprintf(stderr, "[%ld]:fallo al duplicar tuberias para la iteracion %d: %s\n",
                 (long)getpid(), i, strerror(errno));
         return 1; 
      } 
      if ((close(fd[0]) == -1) || (close(fd[1]) == -1)) {
         fprintf(stderr, "[%ld]:fallo al cerrar descriptores extra %d: %s\n",
                (long)getpid(), i, strerror(errno));
         return 1; 
      } 
      if (pidhijo)  /* el padre termina */
         break;
   }

   long a, b, c, d;
   char cad[40];

   if(i == 1) {   /* el padre manda la cadena "1 1" */
     a = b = 1;
     write(STDOUT_FILENO, &a, sizeof(long));
     write(STDOUT_FILENO, &b, sizeof(long));
     read(STDIN_FILENO, &a, sizeof(long));     
     read(STDIN_FILENO, &b, sizeof(long));     
     c = b;
     d = a + b;
   }
   else {
     read(STDIN_FILENO, &a, sizeof(long));     
     read(STDIN_FILENO, &b, sizeof(long)); 
     d = a + b;
     c = b;    
     write(STDOUT_FILENO, &c, sizeof(long));
     write(STDOUT_FILENO, &d, sizeof(long));
   }

   fprintf(stderr, "Este es el proceso %d con ID %ld y padre id %ld, recibe %ld %ld y envia %ld %ld\n",
                    i, (long)getpid(), (long)getppid(), a, b, c, d);

   return 0; 
}     
