#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/sem.h>
#include <sys/stat.h>
#include <sys/wait.h>

#define PERMS (S_IRUSR | S_IWUSR)

int main(int argc, char* argv[]) {
  int i, n;
  char c;
  struct sembuf esperar[1], avisar[1];
  int semid;

  semid = semget(IPC_PRIVATE, 1, PERMS);

  esperar[0].sem_num = 0;
  esperar[0].sem_op = -1;
  esperar[0].sem_flg = IPC_NOWAIT;

  avisar[0].sem_num = 0;
  avisar[0].sem_op = 1;
  avisar[0].sem_flg = IPC_NOWAIT;

  semctl(semid, 0, SETVAL, 1);

  n = atoi(argv[1]);
  for(i = 1; i < n; i++) {
    if(fork() > 0) break;      /* el padre sale */
  }

  /* Entrar en la seccion critica */  
  semop(semid, esperar, 1);
  
  for(c = 'a'; c <= 'z'; c++)
    fprintf(stderr, "%c ", c);
  fprintf(stderr, "\n");

  /* Salir de la seccion critica */
  semop(semid, avisar, 1); 

  wait(NULL);
  if(i == 1) semctl(semid, 0, IPC_RMID);
  return 0;
}
