#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <sys/stat.h>

#define PERMS (S_IRUSR | S_IWUSR)
#define SEM_PADRE 0
#define SEM_HIJO 1

int main() {
  pid_t hijo;
  int n;
  int semid;
  struct sembuf opsem;

  semid = semget(IPC_PRIVATE, 2, PERMS);
  semctl(semid, SEM_PADRE, SETVAL, 2);
  semctl(semid, SEM_HIJO, SETVAL, 0);

  hijo = fork();

  if(hijo) {   /* codigo del padre */
    for(n=0; n<=20; n=n+2) {
      /* Entrar en la seccion critica cerrando el semaforo del padre */
      opsem.sem_num = SEM_PADRE;
      opsem.sem_op = -1;
      opsem.sem_flg = 0;
      semop(semid, &opsem, 1);

      printf("%d\n", n);
  
      /* Abrir el semaforo del hijo */
      opsem.sem_num = SEM_HIJO;
      opsem.sem_op = 1;
      opsem.sem_flg = 0;
      semop(semid, &opsem, 1);
    }
    semctl(semid, 0, IPC_RMID, 0);
    return 0;
  }
  
  /* Hasta aqui solo llega el hijo */
  for(n = 1; n<=20; n=n+2) {
    /* Entrar en la region critica cerrando el semaforo del hijo */
    opsem.sem_num = SEM_HIJO;
    opsem.sem_op = -2;
    opsem.sem_flg = 0;
    semop(semid, &opsem, 1);

    printf("%d\n", n);
  
    /* Abrir el semaforo del padre */
    opsem.sem_num = SEM_PADRE;
    opsem.sem_op = 2;
    opsem.sem_flg = 0;
    semop(semid, &opsem, 1);
  }
  return 0;
}
