#include <stdio.h>
#include <sys/sem.h>
#include <sys/shm.h>
#include <sys/stat.h>
#include "buffer.h"

#define PERM (S_IRUSR | S_IWUSR)

int main(int argc, char* argv[]) {
  key_t claveMem;
  key_t claveSemP, claveSemC, claveHL, claveHO;
  int shmid, semP, semC, semHL, semHO;
  int tam;
  buffer *almacen;

  /* Memoria compartida. Almacen */
  claveMem = ftok("almacen.c", 1);
  tam = atoi(argv[1]);
  shmid = shmget(claveMem, sizeof(buffer) + sizeof(int) * tam, PERM | IPC_CREAT);
  almacen = shmat(shmid, NULL, 0);
  almacen->tam = tam;
  almacen->cola = almacen->cabeza = 0;

  /* Semaforo de productores */
  claveSemP = ftok("almacen.c", 2); 
  semP = semget(claveSemP, 1, PERM | IPC_CREAT); 
  semctl(semP, 0, SETVAL, 1);
  
  /* Semaforo de consumidores */
  claveSemC = ftok("almacen.c", 3); 
  semC = semget(claveSemC, 1, PERM | IPC_CREAT);
  semctl(semC, 0, SETVAL, 1);

  /* Huecos libres */
  claveHL = ftok("almacen.c", 4); 
  semHL = semget(claveHL, 1, PERM | IPC_CREAT); 
  semctl(semHL, 0, SETVAL, tam);

  /* Huecos ocupados */
  claveHO = ftok("almacen.c", 5); 
  semHO = semget(claveHO, 1, PERM | IPC_CREAT); 
  semctl(semHO, 0, SETVAL, 0);
  
  return 0;
}
