#include <stdio.h>
#include <sys/sem.h>
#include <sys/shm.h>
#include <sys/stat.h>
#include "buffer.h"

#define PERM (S_IRUSR | S_IWUSR)

void operarSem(int semid, int op, int num, int flg) {
  struct sembuf opera;

  opera.sem_op = op;
  opera.sem_num = num;
  opera.sem_flg = flg;
  semop(semid, &opera, 1);
}

int main(int argc, char* argv[]) {
  key_t claveMem;
  key_t claveSemC, claveHL, claveHO;
  int shmid, semC, semHL, semHO;
  int numC; /* numero de consumidores */
  int i;
  buffer *almacen;

  /* Memoria compartida. Almacen */
  claveMem = ftok("almacen.c", 1);
  shmid = shmget(claveMem, 0, PERM);
  almacen = shmat(shmid, NULL, 0);

  /* Semaforo de consumidores */
  claveSemC = ftok("almacen.c", 3); 
  semC = semget(claveSemC, 1, PERM);   

  /* Huecos libres */
  claveHL = ftok("almacen.c", 4); 
  semHL = semget(claveHL, 1, PERM); 

  /* Huecos ocupados */
  claveHO = ftok("almacen.c", 5); 
  semHO = semget(claveHO, 1, PERM); 

  /* Crear todos los procesos consumidores */
  numC = atoi(argv[1]);
  for(i=1; i<numC; i++)
    if(fork() > 0) break;

  while(1) {
    /* Comprobar que no hay mas consumidores en la seccion critica */
    operarSem(semC, -1, 0, 0);
    /* Comprobar que hay huecos ocupados */
    operarSem(semHO, -1, 0, 0);

    fprintf(stderr, "Soy %d. Contenido: %d\n", i, almacen->vector[almacen->cabeza]);
    almacen->cabeza = (almacen->cabeza + 1) % almacen->tam;
  

    operarSem(semHL, 1, 0, 0);
    operarSem(semC, 1, 0, 0);  
  }

  return 0;
}
