#include <stdio.h>
#include <sys/sem.h>
#include <sys/shm.h>
#include <sys/stat.h>
#include "buffer.h"

#define PERM (S_IRUSR | S_IWUSR)

void operarSem(int semid, int op, int num, int flg) {
  struct sembuf opera;

  opera.sem_op = op;
  opera.sem_num = num;
  opera.sem_flg = flg;
  semop(semid, &opera, 1);
}

int main(int argc, char* argv[]) {
  key_t claveMem;
  key_t claveSemP, claveHL, claveHO;
  int shmid, semP, semHL, semHO;
  int numP; /* numero de productores */
  int i;
  buffer *almacen;

  /* Memoria compartida. Almacen */
  claveMem = ftok("almacen.c", 1);
  shmid = shmget(claveMem, 0, PERM);
  almacen = shmat(shmid, NULL, 0);
  almacen->vector = (int *)(&almacen->vector + sizeof(int *));
 
  /* Semaforo de productores */
  claveSemP = ftok("almacen.c", 2); 
  semP = semget(claveSemP, 1, PERM);   

  /* Huecos libres */
  claveHL = ftok("almacen.c", 4); 
  semHL = semget(claveHL, 1, PERM); 

  /* Huecos ocupados */
  claveHO = ftok("almacen.c", 5); 
  semHO = semget(claveHO, 1, PERM); 

  /* Crear todos los procesos productores */
  numP = atoi(argv[1]);
  for(i=1; i<numP; i++)
    if(fork() > 0) break;

  while(1) {
    /* Comprobar que no hay mas productores en la seccion critica */
    operarSem(semP, -1, 0, 0);
    /* Comprobar que hay huecos libres */
    operarSem(semHL, -1, 0, 0);

    almacen->vector[almacen->cola] = almacen->cola;
    almacen->cola = (almacen->cola + 1) % almacen->tam;
    fprintf(stderr, "Soy %d. Escribiendo: %d\n", i, almacen->cola);
  
    operarSem(semHO, 1, 0, 0);
    operarSem(semP, 1, 0, 0);  
  }

  return 0;
}
